//Name: Justin Fiedler
//Project: HW3: Neuron
//Course: CS 540

import java.util.Random;

public class Neuron
{	private double[] w;
	private double[] d_w;
	private double output;
	private double g;
	private double g_prime;
	private double delta;

	//constructs a new neuron
	public Neuron(double[] weights)
	{	w = new double[weights.length];
		d_w = new double[weights.length];
		for(int i = 0; i < weights.length; i++)
		{	w[i] = weights[i];
			d_w[i] = 0;
		}
	}

	// if neuron is in the final layer, correctly sets the delta value
	// of the neuron
	public void setFinalLayerDelta(double y)
	{	delta = g_prime * (-(y - output));
	}

	// if neuron is in a hidden layer, correctly sets the delta value
	// of the neuron
	public void setHiddenLayerDelta(double[] weights, double[] deltas)
	{	delta = 0;
		for(int i = 0; i < deltas.length; i++)
		{	delta += weights[i] * deltas[i];
		}
		delta *= g_prime;
	}

	// sets delta w values for each weight in the neuron
	public void setWDeltas(double[] x)
	{	for(int i = 0; i < d_w.length; i++)
		{	d_w[i] += delta * x[i];
		}
	}

	// resets delta w values for each weight in the neuron to 0
	public void resetWDeltas()
	{	for(int i = 0; i < d_w.length; i++)
		{	d_w[i] = 0;
		}
	}

	// updates weights according to current delta w's and learning
	// rate 'alpha'
	public void update_weights(double alpha)
	{	for(int i = 0; i < w.length; i++)
		{	w[i] -= alpha * d_w[i];
			d_w[i] = 0;
		}
	}

	/* output
	 * returns the result of the activation function on the sum
	 *  of all the inputs multiplied by there respective weights
	 */
	public double output(double[] a)
	{	double in = 0;
		// in = weights dot product inputs
		for(int i = 0; i < w.length; i++)
		{	in += w[i] * a[i];
		}
		output = g(in);
		g_prime(in);
		return output;
	}

	/* g
	 * the activation function, in this case sigmoid
	 */
	public double g(double n)
	{	g = 1/(1 + Math.exp(-n));
		return g;
	}

	/* g_prime
	 * the derivative of the activation function, g,
	 * in this case sigmoid'
	 */
	public double g_prime(double n)
	{	g_prime = g(n)*(1 - g(n));
		return g_prime;
	}

	public double delta()
	{	return delta;
	}

	public double g()
	{	return g;
	}

	public double g_prime()
	{	return g_prime;
	}

	public double[] w()
	{	return w;
	}

	public double[] d_w()
	{	return d_w;
	}

	public String toString()
	{	String s = "";
		/*
		s += "WEIGHTS: \n";
		for(int i = 0; i < w.length; i++)
		{	s += " w[" + i + "]= " + w[i];
		}
		*/
		/*
		s += "\nDELTA W'S: \n";
		for(int i = 0; i < d_w.length; i++)
		{	s += " d_w[" + i + "]= " + d_w[i];
		}
		*/
		//s += "\nDELTA: " + delta;
		//s += "\nOUTPUT: " + output;
		return s;
	}
}